function P = LinesIntersectionPoint(p1,t1,p2,t2,varargin)
    g = p2-p1;
    h = cross(t2,g);
    k = cross(t2,t1);
    l = norm(h)/norm(k)*t1;
    P = p1+sign(h'*k)*l;
    if nargin > 4
        plot3(p1(1),p1(2),p1(3),'r.')
        hold on
        grid on
        plot3(p2(1),p2(2),p2(3),'r.')
        plot3([p1(1)-t1(1) p1(1)+t1(1)],...
            [p1(2)-t1(2) p1(2)+t1(2)],...
            [p1(3)-t1(3) p1(3)+t1(3)],'b')
        plot3([p2(1)-t2(1) p2(1)+t2(1)],...
            [p2(2)-t2(2) p2(2)+t2(2)],...
            [p2(3)-t2(3) p2(3)+t2(3)],'g')
        plot3(P(1),P(2),P(3),'y.')
        axis equal
        axis vis3d
    end
end