function [pl,nl,err] = bruteforceSearch(Phi,Th,ps)
options = optimoptions('fminunc');
options.Display = 'off';
options.MaxIterations = 100;
options.OptimalityTolerance = 1e-6;
options.StepTolerance = 1e-6;
du = .05;
ii = 0;
Err = zeros(1);
for phi = Phi
%     disp(phi)
    jj = 0;
    ii = ii + 1;
    for th = Th
        jj = jj + 1;
        uu = [cosd(phi)*cosd(th) 
            sind(phi)*cosd(th)
            sind(th)];
        uu = angle2dcm(0,pi/4,pi/4)*uu;
        
        pm = mean(ps,2);
        us = uu'*(ps-pm);
        umin = min(us)-du;
        umax = max(us)+du;
        j = 0;
        x = [0;0;0];
        K = umin:du:umax;
        if length(K) > 20
            K = linspace(umin,umax,20);
        end
        for k = K
            pp = pm + k*uu;
            us = uu'*(ps-pp);
            ids = abs(us)<du;
            if sum(ids)<10
                continue
            end
            j = j + 1;
            up = cross(randn(3,1),uu);
            up = up/norm(up);
            uc = cross(uu,up);
            Pm = mean(ps(:,ids),2);
            x_ = fminunc(@(x) fc2(x,ps(:,ids),uu,Pm,up,uc),[0;0],options);
%             fc2(x_,ps(:,ids),uu,Pm,up,uc)
            x(:,j) = Pm + x_(1)*up + x_(2)*uc;
%             plt1 = plot3(ps(1,ids),ps(2,ids),ps(3,ids),'.','color',[1 0 0]);
%             plt2 = plot3(ps(1,ids),ps(2,ids),ps(3,ids),'.','color',[(k+5)/10 0 0]);
%             plt3 = plot3(x(1,j),x(2,j),x(3,j),'k.');
%             plt4 = plot3(x(1,j)+[0 uu(1)],x(2,j)+[0 uu(2)],x(3,j)+[0 uu(3)],'k');
% %             pause
%             drawnow
%             delete(plt1)
%             delete(plt2)
%             delete(plt3)
%             delete(plt4)
        end
%         plt = plot3(x(1,:),x(2,:),x(3,:),'k.');
%         pause
%         delete(plt)
        if j > 5
            [pl,~] = BestLineRANSAC(x);
        else
            Err(ii,jj) = 1e5;
            continue
        end
%         uu = nl;
%         pl = pm;
        us = uu'*(ps-pl);
        umin = min(us)-du;
        umax = max(us)+du;
        j = 0;
        nj = 0;
        RMSE = zeros(1);
        for k = umin:du:umax
            pp = pl + k*uu;
            us = uu'*(ps-pp);
            ids = abs(us)<du;
            if sum(ids)==0
                continue
            end
            j = j + 1;
            nj = nj + sum(ids);
            RMSE(j) = fc(pp,ps(:,ids),uu);
        end
        Err(ii,jj) = mean(RMSE);
%         mean(RMSE)
    end
end

[m, id_phi] = min(Err);
[~, id_th] = min(m);
id_phi = id_phi(id_th);
phi = Phi(id_phi);
th = Th(id_th);
uu = [cosd(phi)*cosd(th) 
    sind(phi)*cosd(th)
    sind(th)];
uu = angle2dcm(0,pi/4,pi/4)*uu;
pm = mean(ps,2);
us = uu'*(ps-pm);
umin = min(us)-du;
umax = max(us)+du;
j = 0;
x = [0;0;0];
for k = umin:du:umax
    pp = pm + k*uu;
    us = uu'*(ps-pp);
    ids = abs(us)<du;
    if sum(ids)<10
        continue
    end
    j = j + 1;
    up = cross(randn(3,1),uu);
    up = up/norm(up);
    uc = cross(uu,up);
    Pm = mean(ps(:,ids),2);
    x_ = fminunc(@(x) fc2(x,ps(:,ids),uu,Pm,up,uc),[0;0],options);
    x(:,j) = Pm + x_(1)*up + x_(2)*uc;
end
% plot3(x(1,:),x(2,:),x(3,:),'k.')
[pl,nl] = BestLineRANSAC(x);
err = min(min(Err));