function [f,g] = dlines(inp,pc,nc)
    pl = [inp(1);inp(2);inp(3)];
    ul = [inp(4);inp(5);inp(6)];
    n = length(pc);
    u1 = ul(1);
    u2 = ul(2);
    u3 = ul(3);
    p1 = pl(1);
    p2 = pl(2);
    p3 = pl(3);
    q1 = pc(1,:);
    q2 = pc(2,:);
    q3 = pc(3,:);
    v1 = nc(1,:);
    v2 = nc(2,:);
    v3 = nc(3,:);
    ucv = [u2*v3 - v2*u3;u3*v1 - v3*u1;u1*v2 - v1*u2];
    num = (q1-p1).*ucv(1,:)+(q2-p2).*ucv(2,:)+(q3-p3).*ucv(3,:);
    f = abs(num)./sqrt(sum(ucv.^2));
    g = zeros(6,n);
    g(1,:) =sign(num).*(-(u2*v3 - u3*v2)./sqrt((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2));
    g(2,:) =sign(num).*((u1*v3 - u3*v1)./sqrt((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2));
    g(3,:) =sign(num).*(-(u1*v2 - u2*v1)./sqrt((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2));
    g(4,:) =sign(num).*( (v3.*(p2 - q2) - v2.*(p3 - q3))./sqrt((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2) + ((2*v2.*(u1*v2 - u2*v1) + 2*v3.*(u1*v3 - u3*v1)).*((p1 - q1).*(u2*v3 - u3*v2) - (p2 - q2).*(u1*v3 - u3*v1) + (p3 - q3).*(u1*v2 - u2*v1)))./(2*((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2).^(3/2)));
    g(5,:) =sign(num).*(- (v3.*(p1 - q1) - v1.*(p3 - q3))./sqrt((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2) - ((2*v1.*(u1*v2 - u2*v1) - 2*v3.*(u2*v3 - u3*v2)).*((p1 - q1).*(u2*v3 - u3*v2) - (p2 - q2).*(u1*v3 - u3*v1) + (p3 - q3).*(u1*v2 - u2*v1)))./(2*((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2).^(3/2)));
    g(6,:) =sign(num).*((v2.*(p1 - q1) - v1.*(p2 - q2))./sqrt((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2) - ((2*v1.*(u1*v3 - u3*v1) + 2*v2.*(u2*v3 - u3*v2)).*((p1 - q1).*(u2*v3 - u3*v2) - (p2 - q2).*(u1*v3 - u3*v1) + (p3 - q3).*(u1*v2 - u2*v1)))./(2*((u1*v2 - u2*v1).^2 + (u1*v3 - u3*v1).^2 + (u2*v3 - u3*v2).^2).^(3/2)));
    g = g';
end