function evolute(obj)

if strcmp(obj,'bowl')
    Rc = @(z) 3*(1+(sqrt(10-(z/3-2.8).^2)).*((z/3-2.8)<=2.5));
    z = ((-2.8:.03:-.2)+2.8)*3;
    n1 = 70;
    n2 = 72;
elseif strcmp(obj,'amphora')
    Rc = @(z) 3*((1.705-sqrt(.3-((z/3-2.8)+3.3).^2)).*((z/3-2.8)<=-2.8))+...
        3*((sqrt(14-(z/3-2.8).^2)-1).*((z/3-2.8)<=2.5&(z/3-2.8)>-2.8))+...
        3*((5.3490-sqrt(20-((z/3-2.8)-5.2).^2)).*((z/3-2.8)>2.5));
    z = ((-3.8:.03:7.5)+2.8)*3;
    n1 = 1;
    n2 = 300;
elseif strcmp(obj,'urn')
    Rc = @(z) (12-((z-20).*(1+z.^7/31^7)).^2/50).*(z<=30)+...
        (7.2595-sqrt(23.15-(z-34.5).^2)).*(z>30);
    z = 0:.1:38;
    n1 = 297;
    n2 = 302;
elseif strcmp(obj,'flower pot')
    Rc = @(z) (9*sqrt(1-(z-5).^2/5.5^2)+2).*(z<=9.5)+...
        (7.8071-sqrt(2.65-(z-11).^2)).*(z>9.5);
    z = 0:.03:12.5;
    n1 = 310;
    n2 = 318;
elseif strcmp(obj,'jug')
    p(1) = -4.2362e-08;
    p(2) = -6.901e-06;
    p(3) = 0.0001337;
    p(4) = 0.0010854;
    p(5) = 0.014958;
    p(6) = -0.39374;
    p(7) = -8;
    Rc = @(z) (polyval(p,z));
    z = -5:.1:21;
    n1 = 180;
    n2 = 200;
end
x = Rc(z);
y = z;
f0 = gcf;
f = figure;
plot(-x,y,'b','linewidth',2)
axis equal
grid on
hold on
plot(x,y,'b','linewidth',2)
plot([-x(1) x(1)],[y(1) y(1)],'b','linewidth',2)
plot([-x(end) x(end)],[y(end) y(end)],'b','linewidth',2)

P = [x;y;zeros(1,length(y))];
P = (P(:,1:end-1) + P(:,2:end))/2;
t = [y(2:end)-y(1:end-1);-(x(2:end)-x(1:end-1));zeros(1,length(y)-1)];
t = t./sqrt(sum(t.^2));

pi = zeros(3,10);
k = 0;
for i = 2:length(y)-2
    k = k + 1;
    pi(:,k) = LinesIntersectionPoint(P(:,i),t(:,i),P(:,i+1),t(:,i+1));
    if mod(k,5)==1
        plot([P(1,i) pi(1,k)],[P(2,i) pi(2,k)],'g')
%         plot([P(1,i) P(1,i)-t(1,i)*l],[P(2,i) P(2,i)-t(2,i)*l],'g')
        plot(P(1,i),P(2,i),'y.','markersize',5)
    end
end
% pi = pi(:,sqrt(sum(pi.^2))<34.3);
if strcmp(obj,'jug')
    plot(pi(1,25:n1),pi(2,25:n1),'m.-','linewidth',2)
else
    plot(pi(1,25:n1),pi(2,25:n1),'m.-','linewidth',2)
end
plot(pi(1,n2:end),pi(2,n2:end),'m.-','linewidth',2)
% xlim([-20 20])
% ylim([0 40])

%%
set(groot,'CurrentFigure',f0);
evl = plot3(pi(1,1:n1),pi(3,1:n1),pi(2,1:n1),'m.-','linewidth',2);
rotate(evl,[0 0 1],145,[0 0 0])
