%% ---- Bowl ----
[pc,uc] = getObj('bowl',.02);
[p1,u1,p2,u2,inlier1,inlier2,p01,u01,p02,u02] = CDMS(pc,uc,0.005,.3,500);
evolute('bowl');

plot3(pc(1,:),pc(2,:),pc(3,:),'y.')
hold on
grid on
axis equal vis3d
l = 30;
lines = plot3([pc(1,:);pc(1,:)+uc(1,:)*l],[pc(2,:);pc(2,:)+uc(2,:)*l],[pc(3,:);pc(3,:)+uc(3,:)*l],'b');
l = 10;
plot3([p01(1)-u01(1)*l;p01(1)+u01(1)*l],[p01(2)-u01(2)*l;p01(2)+u01(2)*l],[p01(3)-u01(3)*l;p01(3)+u01(3)*l],'y--','linewidth',1)
plot3([p02(1)-u02(1)*l;p02(1)+u02(1)*l],[p02(2)-u02(2)*l;p02(2)+u02(2)*l],[p02(3)-u02(3)*l;p02(3)+u02(3)*l],'y--','linewidth',1)
plot3(p1(1,:)+l*[u1(1,:) -u1(1,:)],...
    p1(2,:)+l*[u1(2,:) -u1(2,:)],...
    p1(3,:)+l*[u1(3,:) -u1(3,:)],'g','linewidth',1)
plot3(p2(1,:)+l*[u2(1,:) -u2(1,:)],...
    p2(2,:)+l*[u2(2,:) -u2(2,:)],...
    p2(3,:)+l*[u2(3,:) -u2(3,:)],'g','linewidth',1)
for i = find(inlier1)
    lines(i).Color = [0 .3 1];
end
idx = (1-inlier1);
for i = find(idx)
    lines(i).Color = [0 0 0];
end

%% ---- Amphora ----
[pc,uc] = getObj('amphora',.02);
[p1,u1,p2,u2,inlier1,inlier2,p01,u01,p02,u02] = CDMS(pc,uc,0.005,.3,500);
evolute('amphora');

plot3(pc(1,:),pc(2,:),pc(3,:),'y.')
hold on
grid on
axis equal vis3d
lines = plot3([pc(1,:)-uc(1,:)*20;pc(1,:)+uc(1,:)*10],[pc(2,:)-uc(2,:)*20;pc(2,:)+uc(2,:)*10],[pc(3,:)-uc(3,:)*20;pc(3,:)+uc(3,:)*10],'b');
l = 10;
plot3([p01(1)-u01(1)*l;p01(1)+u01(1)*l],[p01(2)-u01(2)*l;p01(2)+u01(2)*l],[p01(3)-u01(3)*l;p01(3)+u01(3)*l],'y--','linewidth',1)
plot3([p02(1)-u02(1)*l;p02(1)+u02(1)*l],[p02(2)-u02(2)*l;p02(2)+u02(2)*l],[p02(3)-u02(3)*l;p02(3)+u02(3)*l],'y--','linewidth',1)
plot3(p1(1,:)+l*[u1(1,:) -u1(1,:)],...
    p1(2,:)+l*[u1(2,:) -u1(2,:)],...
    p1(3,:)+l*[u1(3,:) -u1(3,:)],'g','linewidth',1)
plot3(p2(1,:)+l*[u2(1,:) -u2(1,:)],...
    p2(2,:)+l*[u2(2,:) -u2(2,:)],...
    p2(3,:)+l*[u2(3,:) -u2(3,:)],'g','linewidth',1)
for i = find(inlier2)
    lines(i).Color = [0 .3 1];
end
idx = (1-inlier2);
for i = find(idx)
    lines(i).Color = [0 0 0];
end

%% ---- Urn ----
[pc,uc] = getObj('urn',.02);
[p1,u1,p2,u2,inlier1,inlier2,p01,u01,p02,u02] = CDMS(pc,uc,0.005,.3,500);
evolute('urn');

plot3(pc(1,:),pc(2,:),pc(3,:),'y.')
hold on
grid on
axis equal vis3d
l = 40;
lines = plot3([pc(1,:);pc(1,:)+uc(1,:)*l],[pc(2,:);pc(2,:)+uc(2,:)*l],[pc(3,:);pc(3,:)+uc(3,:)*l],'b');
l = 10;
plot3([p01(1)-u01(1)*l;p01(1)+u01(1)*l],[p01(2)-u01(2)*l;p01(2)+u01(2)*l],[p01(3)-u01(3)*l;p01(3)+u01(3)*l],'y--','linewidth',1)
plot3([p02(1)-u02(1)*l;p02(1)+u02(1)*l],[p02(2)-u02(2)*l;p02(2)+u02(2)*l],[p02(3)-u02(3)*l;p02(3)+u02(3)*l],'y--','linewidth',1)
plot3(p1(1,:)+l*[u1(1,:) -u1(1,:)],...
    p1(2,:)+l*[u1(2,:) -u1(2,:)],...
    p1(3,:)+l*[u1(3,:) -u1(3,:)],'g','linewidth',1)
plot3(p2(1,:)+l*[u2(1,:) -u2(1,:)],...
    p2(2,:)+l*[u2(2,:) -u2(2,:)],...
    p2(3,:)+l*[u2(3,:) -u2(3,:)],'g','linewidth',1)
for i = find(inlier1)
    lines(i).Color = [0 .3 1];
end
idx = (1-inlier1);
for i = find(idx)
    lines(i).Color = [0 0 0];
end

%% ---- Flower pot ----
[pc,uc,ps] = getObj('flower pot',.02);
[p1,u1,p2,u2,inlier1,inlier2,p01,u01,p02,u02] = CDMS(pc,uc,0.005,.3,500);
evolute('flower pot');


plot3(pc(1,:),pc(2,:),pc(3,:),'y.')
hold on
grid on
axis equal vis3d
l = 20;
lines = plot3([pc(1,:);pc(1,:)+uc(1,:)*l],[pc(2,:);pc(2,:)+uc(2,:)*l],[pc(3,:);pc(3,:)+uc(3,:)*l],'b');
l = 10;
plot3([p01(1)-u01(1)*l;p01(1)+u01(1)*l],[p01(2)-u01(2)*l;p01(2)+u01(2)*l],[p01(3)-u01(3)*l;p01(3)+u01(3)*l],'y--','linewidth',1)
plot3([p02(1)-u02(1)*l;p02(1)+u02(1)*l],[p02(2)-u02(2)*l;p02(2)+u02(2)*l],[p02(3)-u02(3)*l;p02(3)+u02(3)*l],'y--','linewidth',1)
plot3(p1(1,:)+l*[u1(1,:) -u1(1,:)],...
    p1(2,:)+l*[u1(2,:) -u1(2,:)],...
    p1(3,:)+l*[u1(3,:) -u1(3,:)],'g','linewidth',1)
plot3(p2(1,:)+l*[u2(1,:) -u2(1,:)],...
    p2(2,:)+l*[u2(2,:) -u2(2,:)],...
    p2(3,:)+l*[u2(3,:) -u2(3,:)],'g','linewidth',1)
for i = find(inlier1)
    lines(i).Color = [0 .3 1];
end
idx = (1-inlier1);
for i = find(idx)
    lines(i).Color = [0 0 0];
end
idx = (1-inlier2);
for i = find(idx)
    lines(i).Color = [.5 0 0];
end
