clear, clc
close all

% obj = 'bowl2';
obj = 'flower pot';
% obj = 'amphora';
% obj = 'urn';

for nois = [.1 .2 .5 1]*1e-1
    fprintf('\n============= nois: %2.1f mm ============\n',nois*10)    
    N = 10;
    d_CDMS = zeros(1,N);
    a_CDMS = zeros(1,N);
    d_PotSAC = zeros(1,N);
    a_PotSAC = zeros(1,N);
    d_BFS = zeros(1,N);
    a_BFS = zeros(1,N);
    
    for itrt = 1:N
        close all
        [pc,uc,ps] = getObj(obj,nois);
        %%
        plot3(pc(1,:),pc(2,:),pc(3,:),'y.')
        hold on
        grid on
        axis equal vis3d
        l = 20;
        lines = plot3([pc(1,:);pc(1,:)+uc(1,:)*l],[pc(2,:);pc(2,:)+uc(2,:)*l],[pc(3,:);pc(3,:)+uc(3,:)*l],'b');
        
        %%
        [p1,u1,p2,u2,inlier1,inlier2,p01,u01,p02,u02] = CDMS(pc,uc,.3,.3,1000);
        
        l = 10;
        plot3([p01(1)-u01(1)*l;p01(1)+u01(1)*l],[p01(2)-u01(2)*l;p01(2)+u01(2)*l],[p01(3)-u01(3)*l;p01(3)+u01(3)*l],'y--','linewidth',1)
        plot3([p02(1)-u02(1)*l;p02(1)+u02(1)*l],[p02(2)-u02(2)*l;p02(2)+u02(2)*l],[p02(3)-u02(3)*l;p02(3)+u02(3)*l],'y--','linewidth',1)
        plot3(p1(1,:)+l*[u1(1,:) -u1(1,:)],...
            p1(2,:)+l*[u1(2,:) -u1(2,:)],...
            p1(3,:)+l*[u1(3,:) -u1(3,:)],'g','linewidth',1)
        plot3(p2(1,:)+l*[u2(1,:) -u2(1,:)],...
            p2(2,:)+l*[u2(2,:) -u2(2,:)],...
            p2(3,:)+l*[u2(3,:) -u2(3,:)],'g','linewidth',1)
        
        k_ = [0;0;1];
        a_CDMS(itrt) = min(acosd(min(abs([u1'*k_ u2'*k_]),1)));
        
        d1 = dlineline(p1,u1,[0;0;0],k_);
        d2 = dlineline(p2,u2,[0;0;0],k_);
        d_CDMS(itrt) = min(d1,d2);
        
        for i = find(inlier1)
            lines(i).Color = [0 .3 1];
        end
        idx = (1-inlier1);
        for i = find(idx)
            lines(i).Color = [0 0 0];
        end
        idx = (1-inlier2);
        for i = find(idx)
            lines(i).Color = [.5 0 0];
        end
        
        %%
        disp('------ PotSAC ------')
        drawnow
        warning off
        options = optimoptions('fminunc');
        options.Display = 'off';
        options.MaxIterations = 100;
        options.OptimalityTolerance = 1e-6;
        options.StepTolerance = 1e-6;
        for i = 1:5
            PotSAC
            th = asin(nl(3));
            phi = atan2(nl(2),nl(1));
            if dlineline(pl,nl,[0;0;0],k_)>20
                continue
            end
            x_ = fminunc(@(x) f_PotSAC(x,pc,uc),[pl;phi;th],options);
            pl = x_(1:3);
            phi = x_(4);
            th = x_(5);
            nl = [cos(th)*cos(phi);cos(th)*sin(phi);sin(th)];
            l = 15;
            lines = plot3([pl(1,:)-nl(1,:)*l;pl(1,:)+nl(1,:)*l],[pl(2,:)-nl(2,:)*l;pl(2,:)+nl(2,:)*l],[pl(3,:)-nl(3,:)*l;pl(3,:)+nl(3,:)*l],'color',[1 .5 0]);
            a_PotSAC(itrt) = acosd(min(abs(nl'*k_),1));
            d_PotSAC(itrt) = dlineline(pl,nl,[0;0;0],k_);
            break;
        end
        drawnow
        %%
        disp('------- BFS --------')
        ps = ps(:,1:10:end);
        if length(ps)>2000
            ps = ps(:,randperm(length(ps),2000));
        end
        cost = 0;
        x = [0;0;0];
        Err = zeros(0);
        u_u1 = [0;0;0];
        u_u2 = [0;0;0];
        Phi = 0:5:180;
        Th = -80:5:80;
        
        ii = 0;
        for phi = Phi
            jj = 0;
            ii = ii + 1;
            for th = Th
                jj = jj + 1;
                uu = [cosd(phi)*cosd(th)
                    sind(phi)*cosd(th)
                    sind(th)];
                uu = angle2dcm(0,pi/4,pi/4)*uu;
                
                if abs(uu'*u1) > abs(u_u1'*u1)
                    phith_u1 = [phi th];
                    u_u1 = uu;
                end
                if abs(uu'*u2) > abs(u_u2'*u2)
                    phith_u2 = [phi th];
                    u_u2 = uu;
                end
            end
        end
        
        Phi = phith_u1(1)-5:5:phith_u1(1)+5;
        Th = phith_u1(2)-5:5:phith_u1(2)+5;
        [pl,nl,err1] = bruteforceSearch(Phi,Th,ps);
        l = 15;
        plot3([pl(1,:)-nl(1,:)*l;pl(1,:)+nl(1,:)*l],[pl(2,:)-nl(2,:)*l;pl(2,:)+nl(2,:)*l],[pl(3,:)-nl(3,:)*l;pl(3,:)+nl(3,:)*l],'m');
        uf = nl;
        pf = pl;
        
        Phi = phith_u2(1)-5:5:phith_u2(1)+5;
        Th = phith_u2(2)-5:5:phith_u2(2)+5;
        [pl,nl,err2] = bruteforceSearch(Phi,Th,ps);
        l = 10;
        plot3([pl(1,:)-nl(1,:)*l;pl(1,:)+nl(1,:)*l],[pl(2,:)-nl(2,:)*l;pl(2,:)+nl(2,:)*l],[pl(3,:)-nl(3,:)*l;pl(3,:)+nl(3,:)*l],'m');
        if (err2 < err1)
            uf = nl;
            pf = pl;
        end
        
        a_BFS(itrt) = acosd(min(abs(uf'*k_),1));
        d_BFS(itrt) = dlineline(pf,uf,[0;0;0],k_);
    end
    %%
    idf_c = a_CDMS>10 | d_CDMS>1;
    idf_p = a_PotSAC>10 | d_PotSAC>1;
    idf_b = a_BFS>10 | d_BFS>1;
    fail_c = sum(idf_c)/N*100;
    fail_p = sum(idf_p)/N*100;
    fail_b = sum(idf_b)/N*100;
    ac_c = mean(a_CDMS(~idf_c));
    ac_p = mean(a_PotSAC(~idf_p & a_PotSAC>0));
    ac_b = mean(a_BFS(~idf_b));
    dc_c = mean(d_CDMS(~idf_c))*10;
    dc_p = mean(d_PotSAC(~idf_p & a_PotSAC>0))*10;
    dc_b = mean(d_BFS(~idf_b))*10;
    af_c = mean(a_CDMS(idf_c));
    af_p = mean(a_PotSAC(idf_p));
    af_b = mean(a_BFS(idf_b));
    df_c = mean(d_CDMS(idf_c))*10;
    df_p = mean(d_PotSAC(idf_p))*10;
    df_b = mean(d_BFS(idf_b))*10;
    fprintf('\n=============================================');
    fprintf('\n| Method | Fail |  ac  |  dc  |  af  |  df  |');
    fprintf('\n---------------------------------------------');
    fprintf('\n| CDMS   | %3.0f%% | %4.1f | %4.1f | %4.1f | %4.1f |',fail_c,ac_c,dc_c,af_c,df_c);
    fprintf('\n| PotSAC | %3.0f%% | %4.1f | %4.1f | %4.1f | %4.1f |',fail_p,ac_p,dc_p,af_p,df_p);
    fprintf('\n| BFS    | %3.0f%% | %4.1f | %4.1f | %4.1f | %4.1f |',fail_b,ac_b,dc_b,af_b,df_b);
    fprintf('\n=============================================');
    fprintf('\n')
end
close all