function [pc,uc,ps,pc2,uc2,ps2] = getObj(obj,nois)
% getObj2: getObj + inside layer
figure
% nois = 1e-2; % cm
alpha = 1;

res = 2;
if strcmp(obj,'bowl')
    Rc = @(z) 3*(1+(sqrt(10-(z/3-2.8).^2)).*((z/3-2.8)<=2.5));
    z = ((-2.8:.03/res:-.2)+2.8)*3;
    c = [.2 .6 1];
    m0 = 25*res;
    n0 = 150*res;
    m = 60*res;
    n = 50*res;
elseif strcmp(obj,'bowl2')
    Rc = @(z) 3*(1+(sqrt(10-(z/3-2.8).^2)).*((z/3-2.8)<=2.5))+3;
    z = ((-2.8:.03/res:.2)+2.8)*3;
    c = [.2 .6 1];
    m0 = 25*res;
    n0 = 150*res;
    m = 60*res/1.2;
    n = 50*res/1.5;
elseif strcmp(obj,'amphora')
    Rc = @(z) 3*((1.705-sqrt(.3-((z/3-2.8)+3.3).^2)).*((z/3-2.8)<=-2.8))+...
        3*((sqrt(14-(z/3-2.8).^2)-1).*((z/3-2.8)<=2.5&(z/3-2.8)>-2.8))+...
        3*((5.3490-sqrt(20-((z/3-2.8)-5.2).^2)).*((z/3-2.8)>2.5));
    z = ((-3.8:.03/res:7.5)+2.8)*3;
    c = [.9 .8 .6];
%     m0 = 240*res;
%     n0 = 150*res;
%     m = 90*res;
%     n = 80*res;
    m0 = 100*.5*res;
    n0 = 150*res;
    m = 50*1.5*res;
    n = 30*3.5*res;
elseif strcmp(obj,'urn')
    Rc = @(z) (12-((z-20).*(1+z.^7/31^7)).^2/50).*(z<=30)+...
        (7.2595-sqrt(23.15-(z-34.5).^2)).*(z>30);
    z = 0:.1/res:38;
    c = [.4 .9 1];
    m0 = (70+150/1.4)*res;
%     m0 = (70+150)*res;
%     m0 = 100;
    n0 = 150*res;
%     m = 160;
    m = 100/2/1.5*res;
%     n = 125;
    n = 100/2.2*res;
    alpha = .3;
elseif strcmp(obj,'flower pot')
    Rc = @(z) (9*sqrt(1-(z-5).^2/5.5^2)+2).*(z<=9.5)+...
        (7.8071-sqrt(2.65-(z-11).^2)).*(z>9.5);
    z = 0:.03/res:12.5;
    c = [.9 .6 .4];
    m0 = 120*res;
    n0 = 150*res;
    m = 150*res*1.2/1.2;
    n = 50*res*1.7/1.7;
    alpha = .3;
end
r = Rc(z);
r = [0 r];
z = [z(1) z];

[X,Y,~] = cylinder(r,500*res);
Z = repmat(z',1,500*res+1);

Xn = X;
Yn = Y;
Xn(3:end-1,:) = Xn(3:end-1,:) + randn(size(X,1)-3,size(X,2))*.01;
Yn(3:end-1,:) = Yn(3:end-1,:) + randn(size(X,1)-3,size(X,2))*.01;

surf(Xn,Yn,Z,'meshstyle','none','facecolor',c,...
    'facealpha',alpha,'facelighting','gouraud','AmbientStrength',0.4,'DiffuseStrength',.4,'SpecularStrength',.4);

X(3:end-1,:) = X(3:end-1,:) + randn(size(X,1)-3,size(X,2))*nois;
Y(3:end-1,:) = Y(3:end-1,:) + randn(size(X,1)-3,size(X,2))*nois;
X(:,end) = X(:,1);
Y(:,end) = Y(:,1);
Z(:,end) = Z(:,1);

hold on
plot3(X(2,:),Y(2,:),Z(2,:),'color',c*.7)
hold on
plot3(X(end,:),Y(end,:),Z(end,:),'color',c*.7)
ga = gca;
if length(ga.Children)<10
    light('position',[5,3,0]*3,'style','infinite')
    light('position',[-5,-5,2]*3,'style','infinite')
end
axis equal vis3d
t = linspace(0,2*pi,200);
plot3([0 0],[0 0],[-3 Z(end)+5],'r','linewidth',2)
view([-100 15])

if strcmp(obj,'amphora')
    xd = zeros(1,100);
    yd = linspace(1.96,.8,100);
    zd = -((yd*1.3-1.3)).^5+5;
    xdd = xd(2:end)-xd(1:end-1);
    ydd = yd(2:end)-yd(1:end-1);
    zdd = zd(2:end)-zd(1:end-1);
    xdd = [xdd(1) xdd];
    ydd = [ydd(1) ydd];
    zdd = [zdd(1) zdd];
    P = [xdd;ydd;zdd];
    P = bsxfun(@rdivide,P,sqrt(sum(P.^2)));
    Xd = repmat(xd,200,1)+repmat(.2*sin(t'),1,100);
    Yd = repmat(yd,200,1)+repmat(.2*cos(t'),1,100).*repmat(-P(3,:),200,1);
    Zd = repmat(zd,200,1)+repmat(.2*cos(t'),1,100).*repmat(P(2,:),200,1);
    Zd = Zd + 2.8;
    Xd = Xd + randn(size(Xd,1),size(Xd,2))*nois;
    Yd = Yd + randn(size(Xd,1),size(Xd,2))*nois;
    Xd = Xd * 3;
    Yd = Yd * 3;
    Zd = Zd * 3;
    surf(Xd,Yd,Zd,'meshstyle','none','facecolor',c,...
        'facealpha',alpha,'facelighting','gouraud','AmbientStrength',0.4,'DiffuseStrength',.4,'SpecularStrength',.4);
    surf(Xd,-Yd,Zd,'meshstyle','none','facecolor',c,...
        'facealpha',alpha,'facelighting','gouraud','AmbientStrength',0.4,'DiffuseStrength',.4,'SpecularStrength',.4);
end

idx = zeros(size(X));
idx(m0:m0+m-1,n0:n0+n-1) = 1;

idx = logical(idx);
X = X(idx);
Y = Y(idx);
Z = Z(idx);
plot3(X,Y,Z,'g.','Markersize',1)

ps = [X Y Z]' + randn(3,length(X))*nois;

Nl = 100;
th = 1.;
rnd = randi(length(X),Nl,1);
N = length(rnd);
% plot3(X(rnd),Y(rnd),Z(rnd),'y.','Markersize',5)

pc = zeros(3,N);
uc = zeros(3,N);
idx = cell(N,1);
for i = 1:N
    idx{i} = (abs(X-X(rnd(i)))<th) & (abs(Y-Y(rnd(i)))<th) & (abs(Z-Z(rnd(i)))<th);
    p = [X(idx{i}),Y(idx{i}),Z(idx{i})]';
%     pc(:,i) = [X(rnd(i)),Y(rnd(i)),Z(rnd(i))];
    pc(:,i) = mean(p,2);
    A = p' - repmat(pc(:,i)',length(p),1);
    [V,~] = eig(A'*A);
    uc(:,i) = V(:,1);
    if (uc(1,i)*pc(1,i)>0)
        uc(:,i) = -uc(:,i);
    end
end
plot3(pc(1,:),pc(2,:),pc(3,:),'y.','Markersize',5)

%%
r = Rc(z)-.3;
r = [0 r];
z = [z(1) z];

[X,Y,~] = cylinder(r,500*res);
Z = repmat(z',1,500*res+1);
X(3:end,:) = X(3:end,:) + randn(size(X,1)-2,size(X,2))*nois;
Y(3:end,:) = Y(3:end,:) + randn(size(X,1)-2,size(X,2))*nois;
X(:,end) = X(:,1);
Y(:,end) = Y(:,1);
Z(:,end) = Z(:,1);

% surf(X,Y,Z,'meshstyle','none','facecolor',c,...
%     'facealpha',alpha,'facelighting','gouraud','AmbientStrength',0.4,'DiffuseStrength',.4,'SpecularStrength',.4);

idx = zeros(size(X));
idx(m0:m0+m-1,n0:n0+n-1) = 1;

idx = logical(idx);
X = X(idx);
Y = Y(idx);
Z = Z(idx);
% plot3(X,Y,Z,'g.','Markersize',1)

ps2 = [X Y Z]';

rnd = randi(length(X),Nl,1);
N = length(rnd);
% plot3(X(rnd),Y(rnd),Z(rnd),'y.','Markersize',5)

pc2 = zeros(3,N);
uc2 = zeros(3,N);
idx = cell(N,1);
for i = 1:N
    idx{i} = (abs(X-X(rnd(i)))<th) & (abs(Y-Y(rnd(i)))<th) & (abs(Z-Z(rnd(i)))<th);
    p = [X(idx{i}),Y(idx{i}),Z(idx{i})]';
    pc2(:,i) = mean(p,2);
%     pc2(:,i) = [X(rnd(i)),Y(rnd(i)),Z(rnd(i))];
    A = p' - repmat(pc2(:,i)',length(p),1);
    [V,~] = eig(A'*A);
    uc2(:,i) = V(:,1);
    if (uc2(1,i)*pc2(1,i)>0)
        uc2(:,i) = -uc2(:,i);
    end
end
